unit uSRTMaker;

interface

 Function GetSRTList(aSRTFile:String; aAlternateFolder:String;aFRate:Real):String;

implementation

uses math,sysutils,classes, AviInfo;

Function GetTimePart(var S:STring):Integer;
var
  X:Longint;
  ch:Char;
Begin
  x:=0;
  Result := 0;
  if s ='' then
    exit;
  if (Length(s)>0) and (s[1]<>'{') then
    Exit;
  While (length(s)>0) do
    Begin
      ch := s[1];
      Delete(s,1,1);
      case ch of
        '}' : Break;
        '0'..'9' : Begin
                     x:=x*10;
                     x:=x+StrToInt(ch);
                   End;
        Else;
      End;
    End;
  Result := x;
End;

Function Leadingzero(X:Longint;len:Integer = 2):String;
Begin
  Result := Inttostr(x);
  While Length(Result)<Len do Result := '0'+Result;
End;

Function GetTextTillToken(Var S:String):String;
var res:String;
   ch:Char;
   comment : Boolean;
Begin
  Res := '';
  Comment := False;
  While Length(s)>0 do
    Begin
      ch:=s[1];
      Delete(s,1,1);
      Case ch of
       '|' : Break;
       '[' : Comment := True;
       ']' : Comment := False;
       Else
         Begin
           if not comment then
             Res := Res + ch;
         End;
      End;
    end;
  while (length(res)>0) and ((res[1]='-') or (res[1]=' ')) do
    Delete(Res,1,1);
  while (length(res)>0) and ((res[Length(res)]='-') or (res[Length(res)]=' ')) do
    Delete(Res,Length(res),1);
  Result := Res;
End;

Function IntToTime(I:Integer;Rate:Real):String;
var
  duration : Real;
  res:String;
Begin
  Res := '';
  Duration := I / Rate;
  Res := Res + Leadingzero( Floor(duration/3600) )+':';
  Duration := Duration - (Floor(duration/3600) *3600);
  Res := Res + Leadingzero( Floor(duration/60) )+':';
  Duration := Duration - (Floor(duration/60)*60);
  Res := Res + Leadingzero( Floor(duration) )+',';
  Duration := Duration - (Floor(duration));
  Res := Res + Leadingzero( Floor(duration*1000),3 );
  Result := Res;
End;

Function SubToStr(aSubFile:String;frate:Real):String;
var
  sub:TStringlist;
  srt:TStringlist;
  FrameRate : Real;
  AviFile : String;
  z:Longint;
  currentstr:String;
  begintime:Integer;
  Endtime:Integer;
  tmpstr:String;
begin
  Sub := TStringlist.Create;
  Sub.LoadFromFile(aSubFile);
  srt:= TStringlist.Create;
  AviFile := aSubFile;
  Delete(AviFile,Length(aviFile)-2,3);
  Avifile := AviFile + 'Avi';

  Framerate := frate;
  if framerate = 0 then
    FrameRate := GetAviInfo(AviFile).RealFrameRate;
  for z:=0 to Sub.Count-1 do
    Begin
      // format is like this!
      //{1177}{1229}[Man]|Don't tell me|about my visa.
      CurrentStr := sub.Strings[z];
      Begintime := GetTimePart(CurrentStr);
      Endtime := GetTimePart(CurrentStr);
      srt.Add(Inttostr(z+1));
      srt.add(IntToTime(Begintime,framerate)+' --> '+IntToTime(Endtime,framerate));
      While CurrentStr <> '' do
        Begin
          tmpstr := GetTextTillToken(CurrentStr);
          if tmpstr <> '' then
            srt.Add(tmpstr);
        end;
      srt.add('');


    End;
  Result := srt.Text;
end;

// only getting here when no srt file found!
Function GetSRTList(aSRTFile:String;aAlternateFolder:String;aFRate:Real):String;
var
  FileWithoutExt:String;
  sl:TStringlist;
Begin
  Result := '';
  Try

    FileWithoutExt := aSRTFile;
    Delete(FileWithoutExt,Length(FileWithoutExt)-2,3);
    if FileExists(FileWithoutExt+'sub') then
      Begin
        Result := SubToStr(FileWithoutExt+'sub',aFRate);
      End;
    FileWithoutExt := ExtractFileName(FileWithoutExt);
    if (Result='') and FileExists(aAlternateFolder+FileWithoutExt+'srt') then
      Begin
        sl:=TStringlist.Create;
        sl.LoadFromFile(aAlternateFolder+FileWithoutExt+'srt');
        Result := sl.Text;
        FreeAndNil(sl);
      End;
    if (result='') and FileExists(aAlternateFolder+FileWithoutExt+'sub') then
      Result := SubToStr(aAlternateFolder+FileWithoutExt+'sub',aFRate);
  Except
    on exception do
      Result := '';
  End;
end;

end.
